# TODO: This implementation is in many cases similiar to the documents_controller in this engine. We need to keep it DRY! (se)

# We have to change the Nukleus::DocumentsController to behave equal to this documents_controller in regards to the accociation of a
# document with a user or a session.
Nukleus::DocumentsController.class_eval do
    # This index requests documents that are associated either to a user id or a session id.
    # If the user is logged in, we have a valid current_user (created by devise). Otherwise we use the session_id.
    def index
        if current_user.present?
            @documents = Nukleus::Document.all_by_user_id(current_user.id)
        else
            @documents = Nukleus::Document.all_by_session_id(session[:session_id])
        end
    end

    # This create accociates adocuments with either a user id or a session id.
    # If the user is logged in, we have a valid current_user (created by devise). Otherwise we use the session_id.
    def create
        filtered_params = document_params
        if current_user.present?
            filtered_params[:user_id] = current_user.id
        else
            filtered_params[:session_id] = session[:session_id]
        end

        @document = Nukleus::Document.new(filtered_params)

        respond_to do |format|
            if @document.save
                format.json { render :show, status: :created }
            else
                format.json { render json: @document.errors, status: :unprocessable_entity }
            end
        end
    end


end
